unit Unit1;
//Poznamka k programu "Nechtel bych jet ve vytahu ovladanem timto systemem..." 
//Program pouziva unit2.pas a unit3.pas v techto unitach sou form2 a form 3
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ComCtrls, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;//komponenta pro navazani spojeni se servrem
    StatusBar1: TStatusBar;//pro data od serveru
    MainMenu1: TMainMenu;//Menu pro navigaci
    Button1: TButton;//pro poslani dat na server
    Label4: TLabel;//napis...
    Edit3: TEdit;//editacni pole ze ktereho se po stisknuti button1 odesle zprava serveru
    Image1: TImage;//Priste du po schodech...
    Main1: TMenuItem;    //Polozka v menu
    Konec1: TMenuItem;    //Polozka v menu
    Run1: TMenuItem;     //Polozka v menu
    Port1: TMenuItem;    //Polozka v menu
    Button2: TButton;  //tlacitko 2
    Button3: TButton;  //tlacitko 3
    Manualniovladani1: TMenuItem;
    Label1: TLabel;    //napis 1
    ListBox1: TListBox;//listbox 1 pro zobrazeni zprav ze serveru
    Label2: TLabel;    //napis 2
    ListBox2: TListBox; //listbox 2 pro kontrolu odesilanych dat na server
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Konec1Click(Sender: TObject);
    procedure Port1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Manualniovladani1Click(Sender: TObject);
  private
    { Private declarations }
  public  //verejne deklarace
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin     //pri vytvoreni formulare 1 se nastavi ip adresa na localhost a port na 5438
ClientSocket1.Port:=5438;
ClientSocket1.Address:='127.0.0.1';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin //pri zavreni applikace se musime odpojit...
if ClientSocket1.Socket.Connected then ClientSocket1.Active:=false;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin{Udalost ktera nastane pri pripojeni k serveru}
StatusBar1.SimpleText:='Pripojeno k serveru...'; {napise text na statusbar}
end;

procedure TForm1.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin  //popisuje to ze se client pripojuje k serveru
StatusBar1.SimpleText:='Conecting...';
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin //Ohlasuje odpojeni klienta...
StatusBar1.SimpleText:='Client je odpojen...';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin//procedura pro poslani textu na server
ClientSocket1.Socket.SendText(edit3.Text+#13+#10);
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var text,cislo,pom,pom2,c1,c2:string;
    i,x:integer;
begin
//Dulezita procedura nastane kdyz nam posle server data
//prijme text od serveru a nacte ho do pomocne promene pom
//ze ktere se pak testuje jestli server poslal prikaz levelbuttondn nebo levelbuttonup
//kdyz ano tak posle serveru zpravu ze ma rozsvitit svetlo v danem patre, posunout tam vytah
//a otevrit vrata...
//Tuto proceduru sem nedodelal...jak bych taky mohl kdyz v delphi delam 3 tydny...
text:=ClientSocket1.Socket.ReceiveText;
ListBox1.Items.Add(text);
i:=pos(' ',text);
pom:=copy(text,1,i);
if pom='levelbuttondn ' then begin
                            cislo:=copy(text,i,i+2);
                            cislo:=stringreplace(cislo,'''','',[rfReplaceAll]);
                            ClientSocket1.Socket.SendText('indidnon'+cislo+#13+#10);
                            ListBox2.Items.add('indidnon'+cislo+#13+#10);
                            ClientSocket1.Socket.SendText('floor '+'1'+cislo+#13+#10);
                            ListBox2.Items.add('floor '+'1'+cislo+#13+#10);
                            ClientSocket1.Socket.SendText('open'+cislo+#13+#10);
                            ListBox2.Items.add('open'+cislo+#13+#10);
                            end;
if pom='levelbuttonup ' then begin
                            cislo:=copy(text,i,i+2);
                            cislo:=stringreplace(cislo,'''','',[rfReplaceAll]);
                            ClientSocket1.Socket.SendText('indiupon'+cislo+#13+#10);
                            ListBox2.Items.add('indiupon'+cislo+#13+#10);
                            ClientSocket1.Socket.SendText('floor '+'1'+cislo+#13+#10);
                            ListBox2.Items.add('floor '+'1'+cislo+#13+#10);
                            ClientSocket1.Socket.SendText('open'+cislo+#13+#10);
                            ListBox2.Items.add('open'+cislo+#13+#10);
                            end;
if pom='cabinbutton ' then begin
                           c1:=copy(text,i,pos(' ',text));
                           delete(text,1,i);
                           c2:=copy(text,1,pos(#13,text));
                           ClientSocket1.Socket.SendText('close '+c1+#13+#10);
                           ListBox2.Items.add('close '+c1+#13+#10);
                           ClientSocket1.Socket.SendText('floor '+c1+' '+c2+#13+#10);
                           ListBox2.Items.add('floor '+c1+' '+c2+#13+#10);
                           ClientSocket1.Socket.SendText('open '+c1+#13+#10);
                           ListBox2.Items.add('open '+c1+#13+#10);
                           ClientSocket1.Socket.SendText('indiupoff '+c1+#13+#10);
                           ListBox2.Items.add('indiupoff '+c1+#13+#10);
                           ClientSocket1.Socket.SendText('indiupon '+c1+#13+#10);
                           ListBox2.Items.add('indiupon '+c1+#13+#10);
                           end;

end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
Close;//asi nejdulezitejsi cast programu KONEC
end;

procedure TForm1.Port1Click(Sender: TObject);
begin
Form2.ShowModal;//Zobrazi dialog s dotazem na zmaenu portu
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
ClientSocket1.Active:=false;//Zrusi pripojeni mezi servrem a clientem...
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
ClientSocket1.Active:=true;//Vytvori pripojeni mezi servrem a clientem...
end;

procedure TForm1.Manualniovladani1Click(Sender: TObject);
begin
form3.ShowModal;//Zobrazi dialog pro manualni ovladani clienta...kde se v zadani psalo ze se to ma delat automaticky:)
//metoda obsluhuj si sam je rozhodne vyhodnejsi(alespon pro programatora...)
end;

end.
